Gst::XImageSink Class Reference
gstreamermm Plugins

A Wrapper for the ximagesink plugin. More...

Inheritance diagram for Gst::XImageSink:
[legend]
Collaboration diagram for Gst::XImageSink:
[legend]

## Public Member Functions

virtual | ~XImageSink ()
GstXImageSink* | gobj ()
| Provides access to the underlying C GObject. More...
const GstXImageSink* | gobj () const
| Provides access to the underlying C GObject. More...
GstXImageSink* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Glib::PropertyProxy < Glib::ustring > | property_display ()
| X Display name. More...
Glib::PropertyProxy_ReadOnly < Glib::ustring > | property_display () const
| X Display name. More...
Glib::PropertyProxy< bool > | property_synchronous ()
| When enabled, runs the X display in synchronous mode. More...
Glib::PropertyProxy_ReadOnly < bool > | property_synchronous () const
| When enabled, runs the X display in synchronous mode. More...
Glib::PropertyProxy < Glib::ustring > | property_pixel_aspect_ratio ()
| The pixel aspect ratio of the device. More...
Glib::PropertyProxy_ReadOnly < Glib::ustring > | property_pixel_aspect_ratio () const
| The pixel aspect ratio of the device. More...
Glib::PropertyProxy< bool > | property_force_aspect_ratio ()
| When enabled, reverse caps negotiation (scaling) will respect original aspect ratio. More...
Glib::PropertyProxy_ReadOnly < bool > | property_force_aspect_ratio () const
| When enabled, reverse caps negotiation (scaling) will respect original aspect ratio. More...
Glib::PropertyProxy< bool > | property_handle_events ()
| When enabled, XEvents will be selected and handled. More...
Glib::PropertyProxy_ReadOnly < bool > | property_handle_events () const
| When enabled, XEvents will be selected and handled. More...
Glib::PropertyProxy< bool > | property_handle_expose ()
| When enabled, the current frame will always be drawn in response to X Expose events. More...
Glib::PropertyProxy_ReadOnly < bool > | property_handle_expose () const
| When enabled, the current frame will always be drawn in response to X Expose events. More...
Glib::PropertyProxy_ReadOnly < guint64 > | property_window_width () const
| Width of the window. More...
Glib::PropertyProxy_ReadOnly < guint64 > | property_window_height () const
| Height of the window. More...
Public Member Functions inherited from Gst::VideoSink
virtual | ~VideoSink ()
GstVideoSink* | gobj ()
| Provides access to the underlying C GObject. More...
const GstVideoSink* | gobj () const
| Provides access to the underlying C GObject. More...
GstVideoSink* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
int | get_height () const
| Get height of Gst::VideoSink. More...
int | get_width () const
| Get width of Gst::VideoSink. More...
Glib::PropertyProxy< bool > | property_show_preroll_frame ()
| Whether to render video frames during preroll. More...
Glib::PropertyProxy_ReadOnly < bool > | property_show_preroll_frame () const
| Whether to render video frames during preroll. More...
Public Member Functions inherited from Gst::BaseSink
virtual | ~BaseSink ()
GstBaseSink* | gobj ()
| Provides access to the underlying C GObject. More...
const GstBaseSink* | gobj () const
| Provides access to the underlying C GObject. More...
GstBaseSink* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
bool | query_latency (bool& live, bool& upstream_live, ClockTime& min_latency, ClockTime& max_latency) const
| Query the sink for the latency parameters. More...
ClockTime | get_latency () const
| Get the currently configured latency. More...
Gst::FlowReturn | do_preroll (const Glib::RefPtr< Gst::MiniObject >& obj)
| If the sink spawns its own thread for pulling buffers from upstream it should call this method after it has pulled a buffer. More...
FlowReturn | wait_preroll ()
| If the Gst::BaseSinkClass.render() method performs its own synchronisation against the clock it must unblock when going from PLAYING to the PAUSED state and call this method before continuing to render the remaining data. More...
ClockReturn | wait_clock (ClockTime time, ClockTimeDiff& jitter)
| This function will block until time is reached. More...
FlowReturn | wait (ClockTime time, ClockTimeDiff& jitter)
| This function will wait for preroll to complete and will then block until time is reached. More...
ClockReturn | wait_clock (ClockTime time)
| This function will block until time is reached. More...
FlowReturn | wait (ClockTime time)
| This function will block until time is reached. More...
void | set_sync (bool sync)
| Configures sink to synchronize on the clock or not. More...
bool | get_sync () const
| Checks if sink is currently configured to synchronize against the clock. More...
void | set_max_lateness (gint64 max_lateness)
| Sets the new max lateness value to max_lateness. More...
gint64 | get_max_lateness () const
| Gets the max lateness value. More...
void | set_qos_enabled (bool enabled)
| Configures sink to send Quality-of-Service events upstream. More...
bool | is_qos_enabled () const
| Checks if sink is currently configured to send Quality-of-Service events upstream. More...
void | set_async_enabled (bool enabled)
| Configures sink to perform all state changes asynchronusly. More...
bool | is_async_enabled () const
| Checks if sink is currently configured to perform asynchronous state changes to PAUSED. More...
void | set_ts_offset (ClockTimeDiff offset)
| Adjust the synchronisation of sink with offset. More...
ClockTimeDiff | get_ts_offset () const
| Get the synchronisation offset of sink. More...
void | set_render_delay (ClockTime delay)
| Set the render delay in sink to delay. More...
ClockTime | get_render_delay () const
| Get the render delay of sink. More...
void | set_blocksize (guint blocksize)
| Set the number of bytes that the sink will pull when it is operating in pull mode. More...
guint | get_blocksize () const
| Get the number of bytes that the sink will pull when it is operating in pull mode. More...
guint64 | get_throttle_time () const
| Get the time that will be inserted between frames to control the maximum buffers per second. More...
void | set_throttle_time (guint64 throttle)
| Set the time that will be inserted between rendered buffers. More...
Glib::RefPtr< Gst::Pad > | get_sink_pad ()
| Gets the sink Gst::Pad object of the element. More...
Glib::RefPtr< const Gst::Pad > | get_sink_pad () const
Glib::PropertyProxy< bool > | property_async ()
| Go asynchronously to PAUSED. More...
Glib::PropertyProxy_ReadOnly < bool > | property_async () const
| Go asynchronously to PAUSED. More...
Glib::PropertyProxy< gint64 > | property_max_lateness ()
| Maximum number of nanoseconds that a buffer can be late before it is dropped (-1 unlimited). More...
Glib::PropertyProxy_ReadOnly < gint64 > | property_max_lateness () const
| Maximum number of nanoseconds that a buffer can be late before it is dropped (-1 unlimited). More...
Glib::PropertyProxy< bool > | property_qos ()
| Generate Quality-of-Service events upstream. More...
Glib::PropertyProxy_ReadOnly < bool > | property_qos () const
| Generate Quality-of-Service events upstream. More...
Glib::PropertyProxy< bool > | property_sync ()
| Sync on the clock. More...
Glib::PropertyProxy_ReadOnly < bool > | property_sync () const
| Sync on the clock. More...
Glib::PropertyProxy< gint64 > | property_ts_offset ()
| Timestamp offset in nanoseconds. More...
Glib::PropertyProxy_ReadOnly < gint64 > | property_ts_offset () const
| Timestamp offset in nanoseconds. More...
Glib::PropertyProxy< guint64 > | property_render_delay ()
| Additional render delay of the sink in nanoseconds. More...
Glib::PropertyProxy_ReadOnly < guint64 > | property_render_delay () const
| Additional render delay of the sink in nanoseconds. More...
Glib::PropertyProxy< guint64 > | property_throttle_time ()
| The time to keep between rendered buffers. More...
Glib::PropertyProxy_ReadOnly < guint64 > | property_throttle_time () const
| The time to keep between rendered buffers. More...
Glib::PropertyProxy< guint > | property_blocksize ()
| Size in bytes to pull per buffer (0 = default). More...
Glib::PropertyProxy_ReadOnly < guint > | property_blocksize () const
| Size in bytes to pull per buffer (0 = default). More...
virtual Glib::RefPtr< Gst::Caps > | get_caps_vfunc (Glib::RefPtr< Gst::Caps > caps) const
| Called to get sink pad caps from the subclass. More...
virtual bool | set_caps_vfunc (const Glib::RefPtr< Gst::Caps >& caps)
| Notify subclass of changed caps. More...
virtual void | get_times_vfunc (const Glib::RefPtr< Gst::Buffer >& buffer, ClockTime& start, ClockTime&end) const
| Called to get the start and end times for synchronising the passed buffer to the clock. More...
virtual bool | start_vfunc ()
| Start processing. More...
virtual bool | stop_vfunc ()
| Stop processing. More...
virtual bool | unlock_vfunc ()
| Unlock any pending access to the resource. More...
virtual bool | event_vfunc (const Glib::RefPtr< Gst::Event >& event)
| Override this to handle events arriving on the sink pad. More...
virtual FlowReturn | preroll_vfunc (const Glib::RefPtr< Gst::Buffer >& buffer)
| Called to present the preroll buffer if desired. More...
virtual FlowReturn | render_vfunc (const Glib::RefPtr< Gst::Buffer >& buffer)
| Called when a buffer should be presented or output, at the correct moment if the Gst::BaseSink has been set to sync to the clock. More...
virtual bool | activate_pull_vfunc (bool active)
| Subclasses should override this when they need to perform special processing when changing to the PLAYING state asynchronously. More...
virtual Glib::RefPtr< Gst::Caps > | fixate_vfunc (const Glib::RefPtr< Gst::Caps >& caps)
| Only useful in pull mode, this vmethod will be called in response to Gst::Pad::fixate_caps() being called on the sink pad. More...
virtual bool | unlock_stop_vfunc ()
| Clear the previous unlock request. More...
virtual FlowReturn | render_list_vfunc (const Glib::RefPtr< Gst::BufferList >& buffer_list)
| Render a BufferList. More...
Public Member Functions inherited from Gst::Element
virtual | ~Element ()
GstElement* | gobj ()
| Provides access to the underlying C GObject. More...
const GstElement* | gobj () const
| Provides access to the underlying C GObject. More...
GstElement* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Glib::RefPtr< Gst::Element > | link (const Glib::RefPtr< Gst::Element >& dest)
| Links this source element to the element. More...
bool | add_pad (const Glib::RefPtr< Gst::Pad >& pad)
| Adds a pad (link point) to element. More...
void | create_all_pads ()
| Creates a pad for each pad template that is always available. More...
Glib::RefPtr< Gst::Pad > | create_compatible_pad (const Glib::RefPtr< const Gst::Pad >& pad, const Glib::RefPtr< const Gst::Caps >& caps)
| Looks for an unlinked pad to which the given pad can link. More...
Glib::RefPtr< Gst::PadTemplate > | get_compatible_pad_template (const Glib::RefPtr< const Gst::PadTemplate >& compattempl)
| Retrieves a pad template from element that is compatible with compattempl. More...
Glib::RefPtr< const Gst::PadTemplate > | get_compatible_pad_template (const Glib::RefPtr< const Gst::PadTemplate >& compattempl) const
| Retrieves a pad template from element that is compatible with compattempl. More...
Glib::RefPtr< Gst::Pad > | get_request_pad (const Glib::ustring& name)
| Retrieves a pad from the element by name (e.g. "src_\\%d"). More...
Glib::RefPtr< Gst::Pad > | request_pad (const Glib::RefPtr< Gst::PadTemplate >& templ, const Glib::ustring& name, const Glib::RefPtr< const Gst::Caps >& caps)
| Retrieves a request pad from the element according to the provided template. More...
Glib::RefPtr< Gst::Pad > | request_pad (const Glib::RefPtr< Gst::PadTemplate >& templ, const Glib::ustring& name)
| A request_pad() convenience overload. More...
Glib::RefPtr< Gst::Pad > | request_pad (const Glib::RefPtr< Gst::PadTemplate >& templ, const Glib::RefPtr< const Gst::Caps >& caps)
| A request_pad() convenience overload. More...
Glib::RefPtr< Gst::Pad > | request_pad (const Glib::RefPtr< Gst::PadTemplate >& templ)
| A request_pad() convenience overload. More...
Glib::RefPtr< Gst::Pad > | get_static_pad (const Glib::ustring& name)
| Retrieves a pad from element by name. More...
Glib::RefPtr< const Gst::Pad > | get_static_pad (const Glib::ustring& name) const
| Retrieves a pad from element by name. More...
void | no_more_pads ()
| Use this function to signal that the element does not expect any more pads to show up in the current pipeline. More...
void | release_request_pad (const Glib::RefPtr< Gst::Pad >& pad)
| Makes the element free the previously requested pad as obtained with get_request_pad(). More...
bool | remove_pad (const Glib::RefPtr< Gst::Pad >& pad)
| Removes pad from element. More...
Gst::Iterator< Gst::Pad > | iterate_pads ()
| Retrieves an iterator of element's pads. More...
Gst::Iterator< const Gst::Pad > | iterate_pads () const
| Retrieves an iterator of element's pads. More...
Gst::Iterator< Gst::Pad > | iterate_sink_pads ()
| Retrieves an iterator of element's sink pads. More...
Gst::Iterator< const Gst::Pad > | iterate_sink_pads () const
| Retrieves an iterator of element's sink pads. More...
Gst::Iterator< Gst::Pad > | iterate_src_pads ()
| Retrieves an iterator of element's source pads. More...
Gst::Iterator< const Gst::Pad > | iterate_src_pads () const
| Retrieves an iterator of element's source pads. More...
void | unlink (const Glib::RefPtr< Gst::Element >& dest)
| Unlinks all source pads of the source element with all sink pads of the sink element to which they are linked. More...
bool | link_pads (const Glib::ustring& srcpadname, const Glib::RefPtr< Gst::Element >& dest, const Glib::ustring& destpadname)
| Links the two named pads of the source and destination elements. More...
void | unlink_pads (const Glib::ustring& srcpadname, const Glib::RefPtr< Gst::Element >& dest, const Glib::ustring& destpadname)
| Unlinks the two named pads of the source and destination elements. More...
bool | link_pads (const Glib::ustring& srcpadname, const Glib::RefPtr< Gst::Element >& dest, const Glib::ustring& destpadname, const Glib::RefPtr< Gst::Caps >& filter)
| Links the two named pads of the source and destination elements. More...
bool | link_pads (const Glib::ustring& srcpadname, const Glib::RefPtr< Gst::Element >& dest, const Glib::ustring& destpadname, PadLinkCheck flags)
| Links the two named pads of the source and destination elements. More...
Glib::RefPtr< Gst::Element > | link (const Glib::RefPtr< Gst::Element >& dest, const Glib::RefPtr< Gst::Caps >& filter)
| Links src to dest using the given caps as filtercaps. More...
void | set_base_time (ClockTime time)
| Set the base time of an element. More...
ClockTime | get_base_time () const
| Returns the base time of the element. More...
void | set_start_time (Gst::ClockTime time)
| Set the start time of an element. More...
Gst::ClockTime | get_start_time () const
| Returns the start time of the element. More...
void | set_bus (const Glib::RefPtr< Gst::Bus >& bus)
| Sets the bus of the element. More...
Glib::RefPtr< Gst::Bus > | get_bus ()
| Returns the bus of the element. More...
Glib::RefPtr< const Gst::Bus > | get_bus () const
| Returns the bus of the element. More...
Glib::RefPtr< Gst::ElementFactory > | get_factory ()
| Retrieves the factory that was used to create this element. More...
Glib::RefPtr< const Gst::ElementFactory > | get_factory () const
| Retrieves the factory that was used to create this element. More...
bool | set_clock (const Glib::RefPtr< Gst::Clock >& clock)
| Sets the clock for the element. More...
Glib::RefPtr< Gst::Clock > | get_clock ()
| Gets the currently configured clock of the element. More...
Glib::RefPtr< const Gst::Clock > | get_clock () const
| Gets the currently configured clock of the element. More...
Glib::RefPtr< Gst::Clock > | provide_clock ()
| Get the clock provided by the given element. More...
Glib::RefPtr< const Gst::Clock > | provide_clock () const
| Get the clock provided by the given element. More...
StateChangeReturn | set_state (State state)
| Sets the state of the element. More...
StateChangeReturn | get_state (State& state, State& pending, ClockTime timeout) const
| Gets the state of the element. More...
bool | set_locked_state (gboolean locked_state)
| Locks the state of an element, so state changes of the parent don't affect this element anymore. More...
bool | is_locked_state () const
| Checks if the state of an element is locked. More...
void | abort_state ()
| Abort the state change of the element. More...
StateChangeReturn | continue_state (StateChangeReturn ret)
| Commit the state change of the element and proceed to the next pending state if any. More...
void | lost_state ()
| Brings the element to the lost state. More...
bool | sync_state_with_parent ()
| Tries to change the state of the element to the same as its parent. More...
StateChangeReturn | change_state (StateChange transition)
| Perform transition on element. More...
void | post_message (int code, int line, MessageType type=Gst::MESSAGE_INFO, const Glib::QueryQuark& domain=get_core_error_quark(), const Glib::ustring& text=Glib::ustring(), const Glib::ustring& debug=Glib::ustring(), const Glib::ustring& file=Glib::ustring(), const Glib::ustring& function=Glib::ustring())
| Post an error, warning or info message on the bus from inside an element. More...
bool | post_message (const Glib::RefPtr< Gst::Message >& message)
| Post a message on the element's Gst::Bus. More...
bool | query (const Glib::RefPtr< Gst::Query >& query) const
| Performs a query on the given element. More...
bool | query_convert (Gst::Format src_format, gint64 src_val, Format dest_format, gint64& dest_val) const
| Queries an element to convert src_val in src_format to dest_format. More...
bool | query_position (Gst::Format format, gint64& cur) const
| Queries an element for the stream position. More...
bool | query_position (Gst::Format format) const
| Queries an element for the stream position. More...
bool | query_duration (Gst::Format format, gint64& duration) const
| Queries an element for the total stream duration. More...
bool | query_duration (Gst::Format format) const
| Queries an element for the total stream duration. More...
bool | seek (Format format, SeekFlags seek_flags, gint64 seek_pos)
| Simple API to perform a seek on the given element, meaning it just seeks to the given position relative to the start of the stream. More...
bool | seek (double rate, Format format, SeekFlags flags, SeekType cur_type, gint64 cur, SeekType stop_type, gint64 stop)
| Sends a seek event to an element. More...
bool | send_event (const Glib::RefPtr< Gst::Event >& event)
| Sends an event to an element. More...
Glib::SignalProxy0< void > | signal_no_more_pads ()
Glib::SignalProxy1< void, const Glib::RefPtr< Gst::Pad >& > | signal_pad_added ()
Glib::SignalProxy1< void, const Glib::RefPtr< Gst::Pad >& > | signal_pad_removed ()
virtual void | release_pad_vfunc (const Glib::RefPtr< Gst::Pad >& pad)
| Called when a request pad is to be released. More...
virtual Glib::RefPtr< Gst::Pad > | request_new_pad_vfunc (Glib::RefPtr< Gst::PadTemplate > templ, const Glib::ustring& name, const Glib::RefPtr< const Gst::Caps >& caps)
| Called when a new pad is requested. More...
virtual StateChangeReturn | get_state_vfunc (State& state, State& pending, ClockTime timeout) const
| Get the state of the element. More...
virtual StateChangeReturn | set_state_vfunc (State state)
| Set a new state on the element. More...
virtual StateChangeReturn | change_state_vfunc (StateChange transition)
| Called by set_state to perform an incremental state change. More...
virtual void | set_bus_vfunc (const Glib::RefPtr< Gst::Bus >& bus)
| Set a Gst::Bus on the element. More...
virtual Glib::RefPtr< Gst::Clock > | provide_clock_vfunc ()
| Gets the Gst::Clock provided by the element. More...
virtual bool | set_clock_vfunc (const Glib::RefPtr< Gst::Clock >& clock)
| Set the Gst::Clock on the element. More...
virtual bool | send_event_vfunc (const Glib::RefPtr< Gst::Event >& event)
| Send a Gst::Event to the element. More...
virtual bool | query_vfunc (const Glib::RefPtr< Gst::Query >&query) const
| Perform a Gst::Query on the element. More...
Glib::RefPtr< Gst::PadTemplate > | get_pad_template (const Glib::ustring& factory_name) const
template<typename T >
Glib::RefPtr< Gst::Element > | property (const Glib::ustring& name, const T& value)
| Sets specified property. More...
Public Member Functions inherited from Gst::Object
virtual | ~Object ()
GstObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GstObject* | gobj () const
| Provides access to the underlying C GObject. More...
GstObject* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
bool | is_element () const
bool | is_element_factory () const
bool | is_pad () const
bool | is_pad_template () const
bool | is_bin () const
guint32 | get_flags () const
| Returns the entire set of flags for the object. More...
bool | set_name (const Glib::ustring& name)
| Sets the name of object, or gives object a guaranteed unique name (if name is `0`). More...
Glib::ustring | get_name () const
| Returns a copy of the name of object. More...
bool | set_parent (const Glib::RefPtr< Gst::Object >& parent)
| Sets the parent of object to parent. More...
Glib::RefPtr< Gst::Object > | get_parent ()
| Returns the parent of object. More...
Glib::RefPtr< const Gst::Object > | get_parent () const
| Returns the parent of object. More...
void | unparent ()
| Clear the parent of object, removing the associated reference. More...
bool | has_ancestor (const Glib::RefPtr< const Gst::Object >& ancestor) const
| Check if object has an ancestor ancestor somewhere up in the hierarchy. More...
Glib::ustring | get_path_string ()
| Generates a string describing the path of object in the object hierarchy. More...
Glib::PropertyProxy < Glib::ustring > | property_name ()
| The name of the object. More...
Glib::PropertyProxy_ReadOnly < Glib::ustring > | property_name () const
| The name of the object. More...
Glib::SignalProxy2< void, const Glib::RefPtr< Object > &, GParamSpec* > | signal_deep_notify ()
Public Member Functions inherited from Gst::Navigation
virtual | ~Navigation ()
GstNavigation* | gobj ()
| Provides access to the underlying C GObject. More...
const GstNavigation* | gobj () const
| Provides access to the underlying C GObject. More...
void | send_event (Gst::Structure& structure)
void | send_key_event (const Glib::ustring& event, const Glib::ustring& key)
void | send_mouse_event (const Glib::ustring& event, int button, double x, double y)
| Sends a mouse event to the navigation interface. More...
void | send_command (Gst::NavigationCommand command)
| Sends the indicated command to the navigation interface. More...
virtual void | send_event_vfunc (Gst::Structure& structure)
| Called when an event has been sent to the Gst::Navigation. More...
Public Member Functions inherited from Gst::VideoOverlay
virtual | ~VideoOverlay ()
GstVideoOverlay* | gobj ()
| Provides access to the underlying C GObject. More...
const GstVideoOverlay* | gobj () const
| Provides access to the underlying C GObject. More...
void | set_window_handle (guintptr window_handle)
| This will call the video overlay's set_window_handle method. More...
void | got_window_handle (guintptr window_handle)
| This will post a "have-window-handle" element message on the bus. More...
void | prepare_window_handle ()
| This will post a "prepare-window-handle" element message on the bus to give applications an opportunity to call gst_video_overlay_set_window_handle() before a plugin creates its own window. More...
void | expose ()
| Tell an overlay that it has been exposed. More...
void | handle_events (bool handle_events)
| Tell an overlay that it should handle events from the window system. More...
bool | set_render_rectangle (int x, int y, int width, int height)
| Configure a subregion as a video target within the window set by gst_video_overlay_set_window_handle(). More...

## Static Public Member Functions

static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< XImageSink > | create ()
| Creates a new ximagesink plugin with a unique name. More...
static Glib::RefPtr< XImageSink > | create (const Glib::ustring& name)
| Creates a new ximagesink plugin with the given name. More...
Static Public Member Functions inherited from Gst::VideoSink
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static void | center_rect (const Gst::VideoRectangle& src, const Gst::VideoRectangle& dst, Gst::VideoRectangle& result, bool scaling=false)
| Takes src rectangle and position it at the center of dst rectangle with or without scaling. More...
Static Public Member Functions inherited from Gst::BaseSink
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gst::Element
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gst::Object
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static bool | check_uniqueness (const Glib::ListHandle< const Gst::Object >& list, const Glib::ustring& name)
| Checks to see if there is any object named name in list. More...
Static Public Member Functions inherited from Gst::Navigation
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gst::VideoOverlay
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions

| XImageSink ()
| XImageSink (const Glib::ustring& name)
Protected Member Functions inherited from Gst::Element
virtual void | on_no_more_pads ()
| This is a default handler for the signal signal_no_more_pads(). More...
virtual void | on_pad_added (const Glib::RefPtr< Gst::Pad >& new_pad)
| This is a default handler for the signal signal_pad_added(). More...
virtual void | on_pad_removed (const Glib::RefPtr< Gst::Pad >& old_pad)
| This is a default handler for the signal signal_pad_removed(). More...
Protected Member Functions inherited from Gst::Object
virtual void | on_deep_notify (const Glib::RefPtr< Object >& prop_object, GParamSpec* prop)
| This is a default handler for the signal signal_deep_notify(). More...
Protected Member Functions inherited from Gst::Navigation
| Navigation ()
| You should derive from this class to use it. More...
Protected Member Functions inherited from Gst::VideoOverlay
| VideoOverlay ()
| You should derive from this class to use it. More...

## Related Functions

(Note that these are not member functions.)
Glib::RefPtr< Gst::XImageSink > | wrap (GstXImageSink* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gst::VideoSink
Glib::RefPtr< Gst::VideoSink > | wrap (GstVideoSink* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gst::BaseSink
Glib::RefPtr< Gst::BaseSink > | wrap (GstBaseSink* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gst::Element
Glib::RefPtr< Gst::Element > | wrap (GstElement* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gst::Object
Glib::RefPtr< Gst::Object > | wrap (GstObject* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gst::Navigation
Glib::RefPtr< Gst::Navigation > | wrap (GstNavigation* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gst::VideoOverlay
Glib::RefPtr< Gst::VideoOverlay > | wrap (GstVideoOverlay* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Detailed Description

A Wrapper for the ximagesink plugin.

Please note that not all plug-ins are available on all systems so care must be taken that they exist before they are used otherwise there will be errors and possibly a crash.

## Constructor & Destructor Documentation

virtual Gst::XImageSink::~XImageSink | ( |  | ) |

virtual

Gst::XImageSink::XImageSink | ( |  | ) |

protected

Gst::XImageSink::XImageSink | ( | const Glib::ustring & | name | ) |

explicit protected

## Member Function Documentation

static Glib::RefPtr<XImageSink> Gst::XImageSink::create | ( |  | ) |

static

Creates a new ximagesink plugin with a unique name.

static Glib::RefPtr<XImageSink> Gst::XImageSink::create | ( | const Glib::ustring & | name | ) |

static

Creates a new ximagesink plugin with the given name.

static GType Gst::XImageSink::get_type | ( |  | ) |

static

Get the GType for this class, for use with the underlying GObject type system.

GstXImageSink* Gst::XImageSink::gobj | ( |  | ) |

inline

Provides access to the underlying C GObject.

const GstXImageSink* Gst::XImageSink::gobj | ( |  | ) | const

inline

Provides access to the underlying C GObject.

GstXImageSink* Gst::XImageSink::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

Glib::PropertyProxy< Glib::ustring > Gst::XImageSink::property_display | ( |  | ) |

X Display name.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gst::XImageSink::property_display | ( |  | ) | const

X Display name.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gst::XImageSink::property_force_aspect_ratio | ( |  | ) |

When enabled, reverse caps negotiation (scaling) will respect original aspect ratio.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gst::XImageSink::property_force_aspect_ratio | ( |  | ) | const

When enabled, reverse caps negotiation (scaling) will respect original aspect ratio.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gst::XImageSink::property_handle_events | ( |  | ) |

When enabled, XEvents will be selected and handled.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gst::XImageSink::property_handle_events | ( |  | ) | const

When enabled, XEvents will be selected and handled.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gst::XImageSink::property_handle_expose | ( |  | ) |

When enabled, the current frame will always be drawn in response to X Expose events.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gst::XImageSink::property_handle_expose | ( |  | ) | const

When enabled, the current frame will always be drawn in response to X Expose events.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< Glib::ustring > Gst::XImageSink::property_pixel_aspect_ratio | ( |  | ) |

The pixel aspect ratio of the device.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gst::XImageSink::property_pixel_aspect_ratio | ( |  | ) | const

The pixel aspect ratio of the device.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gst::XImageSink::property_synchronous | ( |  | ) |

When enabled, runs the X display in synchronous mode.

(unrelated to A/V sync, used only for debugging).

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gst::XImageSink::property_synchronous | ( |  | ) | const

When enabled, runs the X display in synchronous mode.

(unrelated to A/V sync, used only for debugging).

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< guint64 > Gst::XImageSink::property_window_height | ( |  | ) | const

Height of the window.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< guint64 > Gst::XImageSink::property_window_width | ( |  | ) | const

Width of the window.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## Friends And Related Function Documentation

Glib::RefPtr< Gst::XImageSink > wrap | ( | GstXImageSink * | object,
|  | bool | take_copy = `false`
| ) |  |

related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- gstreamermm/ximagesink.h